/*
 * ui.h
 *
 * Copyright (c) 2012, Oleg Tsaregorodtsev
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef UI_H_
#define UI_H_

/* Includes ------------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
#define KEY_PREV        KEY_1
#define KEY_NEXT        KEY_3

#define KEY_DIR_START   KEY_4
#define KEY_DIR_END     KEY_6

#define KEY_APP_PLAYER  KEY_7
#define KEY_APP_MSC     KEY_8

/* Exported types ------------------------------------------------------------*/
typedef enum
{
  UIM_Init,

  UIM_Player,
  UIM_Player_Seeking,

  UIM_Player_HalfLocked,
  UIM_Player_Locked,
  UIM_Player_HalfUnlocked,

  UIM_MSC
} UserInterfaceMode_Typedef;

/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
void UI_Init(void);
void UI_MainCycle(void);
void UI_DeInit(void);

void Vibrator_SendSignal(u16 ms);

#endif /* UI_H_ */
